// //////////////////////////////////////////////////////////////////////
// Import section
// //////////////////////////////////////////////////////////////////////
// STL
#include <cassert>
#include <sstream>
// Boost.Serialization
#include <boost/archive/text_iarchive.hpp>
#include <boost/archive/text_oarchive.hpp>
#include <boost/serialization/access.hpp>
// StdAir
#include <stdair/basic/BasConst_Inventory.hpp>
// AirTSP
#include <airtsp/bom/ReachableUniverse.hpp>
#include <airtsp/bom/SegmentPathPeriod.hpp>

namespace AIRTSP {

  // ////////////////////////////////////////////////////////////////////
  ReachableUniverse::ReachableUniverse()
    : _key (stdair::DEFAULT_ORIGIN), _parent (NULL) {
    assert (false);
  }

  // ////////////////////////////////////////////////////////////////////
  ReachableUniverse::ReachableUniverse (const ReachableUniverse&)
    : _key (stdair::DEFAULT_ORIGIN), _parent (NULL) {
    assert (false);
  }

  // ////////////////////////////////////////////////////////////////////
  ReachableUniverse::ReachableUniverse (const Key_T& iKey)
    : _key (iKey), _parent (NULL) {
  }

  // ////////////////////////////////////////////////////////////////////
  ReachableUniverse::~ReachableUniverse() {
  }

  // ////////////////////////////////////////////////////////////////////
  std::string ReachableUniverse::toString() const {
    std::ostringstream oStr;
    oStr << _key.toString();
    return oStr.str();
  }
  
  // ////////////////////////////////////////////////////////////////////
  void ReachableUniverse::serialisationImplementationExport() const {
    std::ostringstream oStr;
    boost::archive::text_oarchive oa (oStr);
    oa << *this;
  }

  // ////////////////////////////////////////////////////////////////////
  void ReachableUniverse::serialisationImplementationImport() {
    std::istringstream iStr;
    boost::archive::text_iarchive ia (iStr);
    ia >> *this;
  }

  // ////////////////////////////////////////////////////////////////////
  template<class Archive>
  void ReachableUniverse::serialize (Archive& ioArchive,
                                     const unsigned int iFileVersion) {
    ioArchive & _key;
  }

  // ////////////////////////////////////////////////////////////////////
  // Explicit template instantiation
  namespace ba = boost::archive;
  template
  void ReachableUniverse::serialize<ba::text_oarchive> (ba::text_oarchive&,
                                                        unsigned int);
  template
  void ReachableUniverse::serialize<ba::text_iarchive> (ba::text_iarchive&,
                                                        unsigned int);
  // ////////////////////////////////////////////////////////////////////

}

